# -*- coding: utf-8 -*-
# Author: allen
# Copyright (c) 2022 RuiCare All rights reserved.
import os

os.environ["CUDA_VISIBLE_DEVICES"] = "0"
import numpy as np
import tensorflow as tf
from task2 import dense_net
from task2.generator import Generator

if __name__ == '__main__':
    model_path = f'../model/task2_v3.hdf5'

    gen = Generator(excel_path='/home/allen/Desktop/cervix2.xlsx', sheet_index=0)

    config = tf.compat.v1.ConfigProto()
    config.gpu_options.allow_growth = True
    session = tf.compat.v1.Session(config=config)

    model = dense_net.load_dense_net(activation='softmax')
    model.compile(optimizer='adam', loss='mse', metrics=['accuracy'])
    model.load_weights(model_path)

    batch_x, batch_y = gen.get_all_items()
    predict_batch_y = model.predict(batch_x, steps=1, verbose=0)

    for i in range(predict_batch_y.shape[0]):
        original_val = batch_y[i]
        predict_val = predict_batch_y[i]

        original_y = np.where(original_val == np.max(original_val))[0][0]
        predict_y = np.where(predict_val == np.max(predict_val))[0][0]
        print(f'ROW:{str(i + 3).zfill(2)}', f'original_y:{original_y}', f'predict_y:{predict_y}')
