# -*- coding: utf-8 -*-
# Author: allen
# Copyright (c) 2022 RuiCare All rights reserved.
import os

os.environ["CUDA_VISIBLE_DEVICES"] = "0"
os.environ["SM_FRAMEWORK"] = "tf.keras"
import tensorflow as tf
from task2 import dense_net
from task2.generator import Generator
from tensorflow.python.keras.optimizer_v2.adam import Adam
from keras.callbacks import ModelCheckpoint, TensorBoard

if __name__ == '__main__':
    gen = Generator(excel_path='/home/allen/Desktop/cervix.xlsx', batch_size=50)

    save_model_path = f'../model/task2_v4.hdf5'
    pre_model_path = f''

    config = tf.compat.v1.ConfigProto()
    config.gpu_options.allow_growth = True
    session = tf.compat.v1.Session(config=config)

    model = dense_net.load_dense_net(activation='softmax')
    model.compile(optimizer=Adam(lr=0.0001), loss='mean_squared_error', metrics=['accuracy'])

    model._get_distribution_strategy = lambda: None
    if pre_model_path and os.path.exists(pre_model_path):  model.load_weights(pre_model_path)
    checkpoint = ModelCheckpoint(save_model_path, monitor='loss', verbose=1, save_best_only=True)
    board = TensorBoard(log_dir='../log', histogram_freq=1, update_freq='batch')

    model.fit(gen, None, batch_size=gen.batch_size,
              shuffle=True, epochs=5000, steps_per_epoch=gen.steps_per_epoch,
              use_multiprocessing=False, workers=10, max_queue_size=10, callbacks=[checkpoint, board])
